package myexample;
use Dancer2;
use Dancer2::Plugin::Auth::Extensible;
use Dancer2::Plugin::Email;
use Try::Tiny;
use Email::Valid;

our $VERSION = '0.1';

get '/' => sub {
     template 'index.tt', {
	 'title' => 'My First Example'
    };
};

get '/aboutus' => sub {
     template 'aboutus.tt', {
	 'title' => 'MyExample-Aboutus'
    };
};

get '/sentmail' => sub {
     template 'sentmail.tt', {
	 'title' => 'Success'
    };
};

any ['get', 'post'] => '/contactus' => sub {
    my $err;
 
    if ( request->method() eq "POST" ) {
	my $visitornam = body_parameters->get('visitornam');
	my $emailadd = body_parameters->get('emailadd');
	my $subject = body_parameters->get('subject');
	my $data = body_parameters->get('data'); 
	my $checkout = body_parameters->get('checkout');
	my $address = Email::Valid->address($emailadd);
	
if(not $checkout == "42") {
      $err = "Checkout is missing or wrong number.";
} elsif( not $subject) {
      $err = "Message is missing.";
} elsif( not $address) {
      $err = "Invalid email or it's missing.";
} elsif( not $visitornam) {
      $err = "Your name is missing.";
} else {
    try {
        email {
            from    => 'self@myexample.com',
            to      => 'info@myexample.com',
            subject => $subject,
            #body    => "$data \<br\>---\<br\>sender- \<b\>$visitornam \<\\b\>at $emailadd",
			body    => qq{<p> $data \<br\>---\<br\>sender- \<b\>$visitornam \<\\b\>at $emailadd</p>},
            type    => 'html', # can be 'html' or 'plain'
            # Optional extra headers
            headers => {
                "X-Mailer"          => 'National Office XXXX',
                "X-Accept-Language" => 'en',
            }
        };
    } catch {
       $err = "Could not send email.";
            };		
	return redirect '/sentmail';
	    }
    }		

    template 'contactus.tt', {
	 'title' => 'MyExample-Contactus',
	 'err' => $err,
     };
};

get '/private' => require_role Manager => sub {
	  template 'private.tt', {
	 'title' => 'Private'},
	  { layout => 'main2' };
 };

get '/priv2' => require_role Manager => sub {
	  template 'priv2.tt', {
	  'title' => 'Private 2'},
	  { layout => 'main2' };
	  };
     
any qr{.*} => sub {
    status 'not_found';
    template '404.tt', { 
		path => request->path,  
		'title' => 'MyExample-404'	
		};
};

true;

